diff --git a/game/core/src/main/java/net/minecraft/core/util/phys/Vec3.java b/game/core/src/main/java/net/minecraft/core/util/phys/Vec3.java
index a6fa29331..0313a4a0c 100644
--- a/game/core/src/main/java/net/minecraft/core/util/phys/Vec3.java
+++ b/game/core/src/main/java/net/minecraft/core/util/phys/Vec3.java
@@ -1,49 +1,49 @@
 package net.minecraft.core.util.phys;
 
 import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.pool.Poolable;
+import org.jetbrains.annotations.NotNull;
+import net.minecraft.core.util.pool.ObjectPool;
 
-import java.util.ArrayList;
-import java.util.List;
-
-public class Vec3
+public class Vec3 implements Poolable<Vec3>
 {
-    private static final List<Vec3> pool = new ArrayList<>();
-    private static int poolPointer = 0;
+    private static final @NotNull ObjectPool<Vec3> POOL = new ObjectPool<>(() -> new Vec3(0.0, 0.0, 0.0));
+
     public double x;
     public double y;
     public double z;
 
+    @Deprecated
     public static Vec3 getPermanentVec3(double x, double y, double z)
     {
         return new Vec3(x, y, z);
     }
 
+    @Deprecated
     public static void deinitializePool()
     {
-        pool.clear();
-        poolPointer = 0;
+        Vec3.POOL.free();
     }
 
+    @Deprecated
     public static void initializePool()
     {
-        poolPointer = 0;
+        Vec3.POOL.reset();
     }
 
+    @Deprecated
     public static Vec3 getTempVec3(double x, double y, double z)
     {
-        if(poolPointer >= pool.size())
-        {
-            pool.add(getPermanentVec3(0.0D, 0.0D, 0.0D));
-        }
-        return pool.get(poolPointer++).set(x, y, z);
+        return Vec3.POOL.get().set(x, y, z);
     }
 
-    public Vec3 makePermanent(){
-        if (pool.contains(this)){
-            pool.remove(this);
-            poolPointer--;
-        }
-        return this;
+    public static @NotNull Vec3 fromPool(final double x, final double y, final double z) {
+        return Vec3.POOL.get().set(x, y, z);
+    }
+
+    @Deprecated
+    public Vec3 makePermanent() {
+        return this.copyUnpooled();
     }
 
     private Vec3(double x, double y, double z) {
@@ -61,7 +61,19 @@ public class Vec3
         this.z = z;
     }
 
-    private Vec3 set(double x, double y, double z)
+    @Override
+    public @NotNull ObjectPool<Vec3> getPool() {
+        return Vec3.POOL;
+    }
+
+    @Override
+    public void set(final @NotNull Vec3 other) {
+        this.x = other.x;
+        this.y = other.y;
+        this.z = other.z;
+    }
+
+    public Vec3 set(double x, double y, double z)
     {
         this.x = x;
         this.y = y;
@@ -71,7 +83,7 @@ public class Vec3
 
     public Vec3 vectorTo(Vec3 vec3)
     {
-        return getTempVec3(vec3.x - x, vec3.y - y, vec3.z - z);
+        return fromPool(vec3.x - x, vec3.y - y, vec3.z - z);
     }
 
     public Vec3 normalize()
@@ -79,7 +91,7 @@ public class Vec3
         double d = MathHelper.sqrt(x * x + y * y + z * z);
         if(d < 0.0001D)
         {
-            return getTempVec3(0.0D, 0.0D, 0.0D);
+            return fromPool(0.0D, 0.0D, 0.0D);
         } else
         {
             return scale(1/d);
@@ -90,16 +102,16 @@ public class Vec3
     }
     public Vec3 crossProduct(Vec3 vec3)
     {
-        return getTempVec3(y * vec3.z - z * vec3.y, z * vec3.x - x * vec3.z, x * vec3.y - y * vec3.x);
+        return fromPool(y * vec3.z - z * vec3.y, z * vec3.x - x * vec3.z, x * vec3.y - y * vec3.x);
     }
 
     public Vec3 add(double x, double y, double z)
     {
-        return getTempVec3(this.x + x, this.y + y, this.z + z);
+        return fromPool(this.x + x, this.y + y, this.z + z);
     }
 
     public Vec3 scale(double scalar){
-        return getTempVec3(this.x * scalar, this.y * scalar, this.z * scalar);
+        return fromPool(this.x * scalar, this.y * scalar, this.z * scalar);
     }
 
     public double distanceTo(Vec3 vec3)
@@ -136,7 +148,7 @@ public class Vec3
         double diffX = vec3.x - x;
         double diffY = vec3.y - y;
         double diffZ = vec3.z - z;
-        if(diffX * diffX < 1.0000000116860974E-007D)
+        if(diffX * diffX < 1E-007D)
         {
             return null;
         }
@@ -146,7 +158,7 @@ public class Vec3
             return null;
         } else
         {
-            return getTempVec3(x + diffX * d4, y + diffY * d4, z + diffZ * d4);
+            return fromPool(x + diffX * d4, y + diffY * d4, z + diffZ * d4);
         }
     }
 
@@ -165,7 +177,7 @@ public class Vec3
             return null;
         } else
         {
-            return getTempVec3(x + diffX * d4, y + diffY * d4, z + diffZ * d4);
+            return fromPool(x + diffX * d4, y + diffY * d4, z + diffZ * d4);
         }
     }
 
@@ -184,7 +196,7 @@ public class Vec3
             return null;
         } else
         {
-            return getTempVec3(x + diffX * d4, y + diffY * d4, z + diffZ * d4);
+            return fromPool(x + diffX * d4, y + diffY * d4, z + diffZ * d4);
         }
     }
 
@@ -195,7 +207,7 @@ public class Vec3
     }
 
     public Vec3 lerp(final Vec3 vec3, final double progress) {
-        return getTempVec3(this.x + (vec3.x - this.x) * progress, this.y + (vec3.y - this.y) * progress, this.z + (vec3.z - this.z) * progress);
+        return fromPool(this.x + (vec3.x - this.x) * progress, this.y + (vec3.y - this.y) * progress, this.z + (vec3.z - this.z) * progress);
     }
     public void rotateAroundX(float radians)
     {
diff --git a/game/core/src/main/java/net/minecraft/core/util/pool/ObjectPool.java b/game/core/src/main/java/net/minecraft/core/util/pool/ObjectPool.java
new file mode 100644
index 000000000..b633a533d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/util/pool/ObjectPool.java
@@ -0,0 +1,105 @@
+package net.minecraft.core.util.pool;
+
+import org.jetbrains.annotations.NotNull;
+
+import java.util.ArrayList;
+import java.util.List;
+
+/**
+ * Provides an abstraction over a pooled set of objects that can be reused.
+ * @param <T> The type of object to be pooled.
+ */
+public class ObjectPool<T extends Poolable<T>> {
+    /**
+     * A list of all created ObjectPools, used for bulk resets and frees.
+     */
+    private static final @NotNull List<ObjectPool<?>> ALL_POOLS = new ArrayList<>();
+
+    /**
+     * Resets the pool pointer for all pools to 0, but does not free any pooled objects, allowing them to be reused.
+     */
+    public static void resetAllPools() {
+        for (final @NotNull ObjectPool<?> pool : ObjectPool.ALL_POOLS) {
+            pool.reset();
+        }
+    }
+
+    /**
+     * Completely frees all pools, allowing their memory to be freed. Should generally only be called in memory-constrained
+     * situations.
+     */
+    public static void freeAllPools() {
+        for (final @NotNull ObjectPool<?> pool : ObjectPool.ALL_POOLS) {
+            pool.free();
+        }
+    }
+
+    /**
+     * A factory that generates new default instances of the pooled object.
+     * @param <T> The type of object to be pooled.
+     */
+    public interface PooledObjectFactory<T> {
+        @NotNull T createDefault();
+    }
+
+    /**
+     * The factory that generates instances of T.
+     */
+    private final @NotNull ObjectPool.PooledObjectFactory<T> factory;
+
+    /**
+     * The pool containing instances of T.
+     */
+    private final List<T> pool = new ArrayList<>();
+
+    /**
+     * The next index to take a pooled object from when requested.
+     */
+    private int poolPointer = 0;
+
+    /**
+     * Creates a new instance of the ObjectPool.
+     * @param factory A factory that generates instances of T.
+     */
+    public ObjectPool(final @NotNull ObjectPool.PooledObjectFactory<T> factory) {
+        this.factory = factory;
+
+        ObjectPool.ALL_POOLS.add(this);
+    }
+
+    /**
+     * Fetches an instance of T, whose lifetime is not guaranteed beyond the current frame.
+     * @return An instance of T to be used.
+     */
+    public @NotNull T get() {
+        if (this.poolPointer >= this.pool.size()) {
+            this.pool.add(this.factory.createDefault());
+        }
+
+        return this.pool.get(this.poolPointer++);
+    }
+
+    /**
+     * Creates a new instance of T which is not part of the pool.
+     * Do not make this public, or I will have an aneurysm.
+     */
+    /* package-private */ @NotNull T getUnpooled() {
+        return this.factory.createDefault();
+    }
+
+    /**
+     * Resets the pool pointer to 0, but does not free any existing instances of T, allowing them to be reused.
+     */
+    public void reset() {
+        this.poolPointer = 0;
+    }
+
+    /**
+     * Completely frees the pool, de-allocating any memory inside it. Should generally only be called in memory-constrained
+     * situations.
+     */
+    public void free() {
+        this.pool.clear();
+        this.poolPointer = 0;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/util/pool/Poolable.java b/game/core/src/main/java/net/minecraft/core/util/pool/Poolable.java
new file mode 100644
index 000000000..5db41bd1d
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/util/pool/Poolable.java
@@ -0,0 +1,23 @@
+package net.minecraft.core.util.pool;
+
+import org.jetbrains.annotations.NotNull;
+
+public interface Poolable<T extends Poolable<T>> {
+    @NotNull ObjectPool<T> getPool();
+
+    void set(final @NotNull T other);
+
+    default @NotNull T copyUnpooled() {
+        final @NotNull T copy = getPool().getUnpooled();
+        copy.set((T) this);
+
+        return copy;
+    }
+
+    default @NotNull T copyPooled() {
+        final @NotNull T copy = getPool().get();
+        copy.set((T) this);
+
+        return copy;
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/Explosion.java b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
index 721d688eb..efaa9e170 100644
--- a/game/core/src/main/java/net/minecraft/core/world/Explosion.java
+++ b/game/core/src/main/java/net/minecraft/core/world/Explosion.java
@@ -151,8 +151,8 @@ public class Explosion {
         int z1 = MathHelper.floor(explosionZ - (double) explosionSize2 - 1.0D);
         int z2 = MathHelper.floor(explosionZ + (double) explosionSize2 + 1.0D);
         
-        List<Entity> list = new ArrayList<>(worldObj.getEntitiesWithinAABBExcludingEntity(exploder, AABB.getTemporaryBB(x1, y1, z1, x2, y2, z2)));
-        Vec3 vec3 = Vec3.getTempVec3(explosionX, explosionY, explosionZ);
+        List<Entity> list = new ArrayList<>(worldObj.getEntitiesWithinAABBExcludingEntity(exploder, AABB.fromPool(x1, y1, z1, x2, y2, z2)));
+        Vec3 vec3 = Vec3.fromPool(explosionX, explosionY, explosionZ);
         for (Entity entity : list) {
             double d4 = entity.distanceTo(explosionX, explosionY, explosionZ) / (double) explosionSize2;
             if (d4 <= 1.0D) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
index e833a79df..329f6a6f6 100644
--- a/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
+++ b/game/core/src/main/java/net/minecraft/core/world/ExplosionCannonball.java
@@ -86,8 +86,8 @@ public class ExplosionCannonball extends Explosion{
         int i2 = MathHelper.floor(explosionZ - (double)explosionSize - 1.0D);
         int j2 = MathHelper.floor(explosionZ + (double)explosionSize + 1.0D);
 //        List<Entity> list = worldObj.getEntitiesWithinAABBExcludingEntity(exploder, AABB.getBoundingBoxFromPool(k, k1, i2, i1, l1, j2));
-        List<Entity> list = worldObj.getEntitiesWithinAABB(Entity.class, AABB.getTemporaryBB(k, k1, i2, i1, l1, j2)); // Cannon balls can explode their owners
-        Vec3 vec3 = Vec3.getTempVec3(explosionX, explosionY, explosionZ);
+        List<Entity> list = worldObj.getEntitiesWithinAABB(Entity.class, AABB.fromPool(k, k1, i2, i1, l1, j2)); // Cannon balls can explode their owners
+        Vec3 vec3 = Vec3.fromPool(explosionX, explosionY, explosionZ);
         for(int k2 = 0; k2 < list.size(); k2++)
         {
             Entity entity = list.get(k2);
diff --git a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
index eeb684cc3..aa187ae6f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
+++ b/game/core/src/main/java/net/minecraft/core/world/SpawnerMobs.java
@@ -264,7 +264,7 @@ public final class SpawnerMobs
                         if(pathEntity != null && pathEntity.length > 1)
                         {
                             Node pathPoint = pathEntity.last();
-                            boolean isCollisionFree = world.checkBlockCollisionBetweenPoints(Vec3.getTempVec3(player.x, player.y + 1.5f, player.z), Vec3.getTempVec3(pathPoint.x, pathPoint.y + 1.5f, pathPoint.z)) == null;
+                            boolean isCollisionFree = world.checkBlockCollisionBetweenPoints(Vec3.fromPool(player.x, player.y + 1.5f, player.z), Vec3.fromPool(pathPoint.x, pathPoint.y + 1.5f, pathPoint.z)) == null;
                             if(Math.abs(pathPoint.x + 0.5f - player.x) < 1.5 && Math.abs(pathPoint.z + 0.5f - player.z) < 1.5 && Math.abs(pathPoint.y + 0.5f - player.y) < 1.5 && isCollisionFree) {
                                 return true;
                             }
@@ -358,7 +358,7 @@ public final class SpawnerMobs
 							if(pathEntity != null && pathEntity.length > 1)
                             {
 								Node pathPoint = pathEntity.last();
-                                boolean isCollisionFree = world.checkBlockCollisionBetweenPoints(Vec3.getTempVec3(player.x, player.y + 1.5f, player.z), Vec3.getTempVec3(pathPoint.x, pathPoint.y + 1.5f, pathPoint.z)) == null;
+                                boolean isCollisionFree = world.checkBlockCollisionBetweenPoints(Vec3.fromPool(player.x, player.y + 1.5f, player.z), Vec3.fromPool(pathPoint.x, pathPoint.y + 1.5f, pathPoint.z)) == null;
 								if(Math.abs(pathPoint.x + 0.5f - player.x) < 1.5 && Math.abs(pathPoint.z + 0.5f - player.z) < 1.5 && Math.abs(pathPoint.y + 0.5f - player.y) < 1.5 && isCollisionFree) {
 									ChunkCoordinates pos = BlockLogicBed.getNearestEmptyChunkCoordinates(world, MathHelper.floor(player.x), MathHelper.floor(player.y), MathHelper.floor(player.z), 1);
 									if(pos == null) {
diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 583ddf01e..83f15db1f 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -1275,7 +1275,7 @@ public class World implements WorldSource {
                 start.y += d7 * d5;
                 start.z = d2;
             }
-            Vec3 vec32 = Vec3.getTempVec3(start.x, start.y, start.z);
+            Vec3 vec32 = Vec3.fromPool(start.x, start.y, start.z);
             blockStartX = (int)(vec32.x = MathHelper.floor(start.x));
             if(byte0 == 5)
             {
@@ -1936,7 +1936,7 @@ public class World implements WorldSource {
             return false;
         }
         boolean flag = false;
-        Vec3 vec3 = Vec3.getTempVec3(0.0D, 0.0D, 0.0D);
+        Vec3 vec3 = Vec3.fromPool(0.0D, 0.0D, 0.0D);
         for(int k1 = i; k1 < j; k1++)
         {
             for(int l1 = k; l1 < l; l1++)
@@ -2106,7 +2106,7 @@ public class World implements WorldSource {
                     double d3 = aabb.minX + (aabb.maxX - aabb.minX) * (double)f;
                     double d4 = aabb.minY + (aabb.maxY - aabb.minY) * (double)f1;
                     double d5 = aabb.minZ + (aabb.maxZ - aabb.minZ) * (double)f2;
-                    if(checkBlockCollisionBetweenPoints(Vec3.getTempVec3(d3, d4, d5), vec3) == null)
+                    if(checkBlockCollisionBetweenPoints(Vec3.fromPool(d3, d4, d5), vec3) == null)
                     {
                         i++;
                     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java b/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
index be63f9911..ca50a4c41 100644
--- a/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
+++ b/game/core/src/main/java/net/minecraft/core/world/config/spawning/SpawnerConfig.java
@@ -63,7 +63,7 @@ public class SpawnerConfig {
         CompoundTag overrides = tag.getCompound("overrides");
         for (Map.Entry<String, Tag<?>> tagEntry : overrides.getValue().entrySet()) {
             try {
-                mobSpawnOverrides.put(NamespaceID.getPermanent(tagEntry.getKey()), ((ByteTag)tagEntry.getValue()).getValue() != 0);
+                mobSpawnOverrides.put(NamespaceID.fromPool(tagEntry.getKey()).copyUnpooled(), ((ByteTag)tagEntry.getValue()).getValue() != 0);
             } catch (HardIllegalArgumentException e) {
                 LOGGER.error("Failed to convert string '{}' to namespace id!", tagEntry.getKey(), e);
             }
diff --git a/game/core/src/main/java/net/minecraft/core/world/pathfinder/Path.java b/game/core/src/main/java/net/minecraft/core/world/pathfinder/Path.java
index 1de15536f..2b349dafd 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pathfinder/Path.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pathfinder/Path.java
@@ -42,6 +42,6 @@ public class Path
         double x = (double) nodes[index].x + (double)(int)(entity.bbWidth + 2.0F) * 0.5D;
         double y = nodes[index].y;
         double z = (double) nodes[index].z + (double)(int)(entity.bbWidth + 2.0F) * 0.5D;
-        return Vec3.getTempVec3(x, y, z);
+        return Vec3.fromPool(x, y, z);
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
index 6c8784f47..6121096ba 100644
--- a/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
+++ b/game/core/src/main/java/net/minecraft/core/world/weather/WeatherStorm.java
@@ -66,7 +66,7 @@ public class WeatherStorm extends WeatherRain {
         weight += checkY;
         weight += material.getConductivity();
 
-        final @NotNull List<@NotNull Mob> entityList = world.getEntitiesWithinAABB(Mob.class, AABB.getTemporaryBB(checkX, checkY, checkZ, checkX + 1, checkY + 1, checkZ + 1));
+        final @NotNull List<@NotNull Mob> entityList = world.getEntitiesWithinAABB(Mob.class, AABB.fromPool(checkX, checkY, checkZ, checkX + 1, checkY + 1, checkZ + 1));
         if (!entityList.isEmpty()) {
             weight += 4; // :)
         }
diff --git a/game/core/src/main/resources/lang/en_US/gui.lang b/game/core/src/main/resources/lang/en_US/gui.lang
index 8b02d1c14..5991b3a2c 100644
--- a/game/core/src/main/resources/lang/en_US/gui.lang
+++ b/game/core/src/main/resources/lang/en_US/gui.lang
@@ -172,8 +172,9 @@ gui.main_menu.label.splash.halloween=Happy Halloween!
 gui.main_menu.label.splash.new_year=Happy New Year!
 gui.main_menu.label.disclaimer.1=Copyright Mojang Studios. Not an official Minecraft product.
 gui.main_menu.label.disclaimer.2=Not approved by or associated with Mojang Studios or Microsoft.
-gui.main_menu.label.downloading_resources.1=Downloading resources: %s / %s
+gui.main_menu.label.downloading_resources.1=Downloading resources
 gui.main_menu.label.downloading_resources.2=Sounds may not play during this process!
+gui.main_menu.label.downloading_resources.connection.error=Could not download sounds!
 gui.main_menu.button.singleplayer=Singleplayer
 gui.main_menu.button.multiplayer=Multiplayer
 gui.main_menu.button.multiplayer.disabled=Multiplayer (not ready yet!)
@@ -260,6 +261,7 @@ gui.options.page.debug.button.open.datadumper=Run Data Dumper
 gui.options.page.debug.button.open.sound_test=Open Sound Test
 gui.options.page.debug.button.open.texture_viewer=Open Texture Viewer
 gui.options.page.debug.button.open.font_tester=Open Font Test
+gui.options.page.debug.button.open.nbt_tester=NBT Editor Test
 gui.options.page.debug.button.open.achievements=Open Achievements
 gui.options.page.debug.button.wipestats=Delete Stats
 gui.options.page.debug.button.unlockedall=Unlock all stats
diff --git a/game/core/src/main/resources/lang/en_US/item.lang b/game/core/src/main/resources/lang/en_US/item.lang
index 42ce591a0..34869c379 100644
--- a/game/core/src/main/resources/lang/en_US/item.lang
+++ b/game/core/src/main/resources/lang/en_US/item.lang
@@ -460,6 +460,8 @@ item.rope.desc=Strong enough to climb.
 
 item.wand.monster.name=Summoning Wand
 item.wand.monster.desc=A magical tool allowing the wielder to manifest living entities.
+item.wand.nbt.name=NBT Wand
+item.wand.nbt.desc=A magical tool allowing the wielder to modify an object's data.
 
 item.paintbrush.name=Paintbrush
 item.paintbrush.desc=Can be loaded with dye and used to paint blocks.
diff --git a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
index cf4398576..9ec8e158f 100644
--- a/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
+++ b/game/server/src/main/java/net/minecraft/server/MinecraftServer.java
@@ -55,6 +55,7 @@ import net.minecraft.core.net.command.commands.CommandTestFor;
 import net.minecraft.core.net.command.commands.CommandTime;
 import net.minecraft.core.net.command.commands.CommandWeather;
 import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.util.pool.ObjectPool;
 import net.minecraft.core.util.helper.UUIDHelper;
 import net.minecraft.server.entity.player.PlayerServer;
 import net.minecraft.server.net.command.ConsoleCommandSource;
@@ -63,8 +64,6 @@ import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.sound.SoundTypes;
 import net.minecraft.core.util.helper.RSA;
 import net.minecraft.core.util.helper.RestHandler;
-import net.minecraft.core.util.phys.AABB;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
@@ -118,9 +117,7 @@ import java.net.InetAddress;
 import java.net.UnknownHostException;
 import java.util.ArrayList;
 import java.util.Collections;
-import java.util.HashMap;
 import java.util.List;
-import java.util.Map;
 import java.util.Random;
 
 import static net.minecraft.core.Global.CURRENT_SAVE_VERSION;
@@ -733,8 +730,7 @@ public class MinecraftServer
 
     private void doTick()
     {
-        AABB.initializePool();
-        Vec3.initializePool();
+        ObjectPool.resetAllPools();
         deathTime++;
         for (WorldServer worldServer : dimensionWorlds.values())
         {
diff --git a/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java b/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
index 92053153e..2f3b13fad 100644
--- a/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
+++ b/game/server/src/main/java/net/minecraft/server/net/command/ServerCommandSource.java
@@ -74,7 +74,7 @@ public class ServerCommandSource implements CommandSource, IServerCommandSource
     @Override
     public @NotNull Vec3 getBlockCoordinates() {
         Vec3 coordinates = this.getCoordinates(true);
-        return Vec3.getTempVec3(MathHelper.floor(coordinates.x), MathHelper.floor(coordinates.y), MathHelper.floor(coordinates.z));
+        return Vec3.fromPool(MathHelper.floor(coordinates.x), MathHelper.floor(coordinates.y), MathHelper.floor(coordinates.z));
     }
 
     @Override
diff --git a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
index 7f5267794..d5bdbf90f 100644
--- a/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
+++ b/game/server/src/main/java/net/minecraft/server/net/handler/PacketHandlerServer.java
@@ -648,7 +648,7 @@ public class PacketHandlerServer extends PacketHandler
                 float f3 = -MathHelper.cos(-playerEntity.xRot * 0.01745329F);
                 float f4 = MathHelper.sin(-playerEntity.xRot * 0.01745329F);
 
-                Vec3 viewVector = Vec3.getTempVec3(f2 * f3, f4, f1 * f3);
+                Vec3 viewVector = Vec3.fromPool(f2 * f3, f4, f1 * f3);
 
                 viewVector.x *= 8;
                 viewVector.y *= 8;
@@ -657,7 +657,7 @@ public class PacketHandlerServer extends PacketHandler
                 viewVector.y += playerEntity.y;
                 viewVector.z += playerEntity.z;
 
-                Vec3 playerViewPos = Vec3.getTempVec3(playerEntity.x, playerEntity.y + playerEntity.getHeadHeight(), playerEntity.z);
+                Vec3 playerViewPos = Vec3.fromPool(playerEntity.x, playerEntity.y + playerEntity.getHeadHeight(), playerEntity.z);
 
                 HitResult movingObjectPosition = targetEntity.bb.clip(playerViewPos, viewVector);
 
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
index 0c6416598..266f41298 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/TestChunkProvider.java
@@ -22,7 +22,7 @@ public class TestChunkProvider implements ChunkProvider {
 
                     @Override
                     public NamespaceID getID() {
-                        return NamespaceID.getPermanent("viewer", "test");
+                        return NamespaceID.fromPool("viewer", "test");
                     }
 
                     @Override
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
index 38dadc049..e807a1b2a 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/BTABiome.java
@@ -20,7 +20,7 @@ public class BTABiome implements Biome {
     @Override
     public NamespaceID getID() {
         try {
-            return NamespaceID.getPermanent(Registries.BIOMES.getKey(biome));
+            return NamespaceID.fromPool(Registries.BIOMES.getKey(biome)).copyUnpooled();
         } catch (HardIllegalArgumentException e) {
             throw new IllegalArgumentException(e);
         }
